/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Contents of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.107 - (hide annotations) (download)
Fri Sep 23 04:14:02 2011 UTC (2 years, 7 months ago) by vapier
Branch: MAIN
Changes since 1.106: +28 -14 lines
handle multiline ACLOCAL_AMFLAGS #383525 by Mikael Morin

1 vapier 1.105 # Copyright 1999-2011 Gentoo Foundation
2 vapier 1.6 # Distributed under the terms of the GNU General Public License v2
3 vapier 1.107 # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.106 2011/08/22 19:39:52 vapier Exp $
4 vapier 1.76
5     # @ECLASS: autotools.eclass
6     # @MAINTAINER:
7     # base-system@gentoo.org
8     # @BLURB: Regenerates auto* build scripts
9     # @DESCRIPTION:
10     # This eclass is for safely handling autotooled software packages that need to
11     # regenerate their build scripts. All functions will abort in case of errors.
12 azarah 1.1 #
13 azarah 1.11 # NB: If you add anything, please comment it!
14 azarah 1.1
15 flameeyes 1.37 inherit eutils libtool
16 azarah 1.11
17 vapier 1.76 # @ECLASS-VARIABLE: WANT_AUTOCONF
18     # @DESCRIPTION:
19     # The major version of autoconf your package needs
20 vapier 1.94 : ${WANT_AUTOCONF:=latest}
21 vapier 1.76
22     # @ECLASS-VARIABLE: WANT_AUTOMAKE
23     # @DESCRIPTION:
24     # The major version of automake your package needs
25 vapier 1.94 : ${WANT_AUTOMAKE:=latest}
26 flameeyes 1.63
27 vapier 1.105 # @ECLASS-VARIABLE: WANT_LIBTOOL
28     # @DESCRIPTION:
29     # Do you want libtool? Valid values here are "latest" and "none".
30     : ${WANT_LIBTOOL:=latest}
31    
32 robbat2 1.95 # @ECLASS-VARIABLE: _LATEST_AUTOMAKE
33 vapier 1.100 # @INTERNAL
34 robbat2 1.95 # @DESCRIPTION:
35     # CONSTANT!
36 flameeyes 1.96 # The latest major version/slot of automake available on each arch.
37 robbat2 1.95 # If a newer version is stable on any arch, and is NOT reflected in this list,
38     # then circular dependencies may arise during emerge @system bootstraps.
39     # Do NOT change this variable in your ebuilds!
40 vapier 1.99 _LATEST_AUTOMAKE='1.11'
41 robbat2 1.95
42 vapier 1.40 _automake_atom="sys-devel/automake"
43     _autoconf_atom="sys-devel/autoconf"
44 peper 1.55 if [[ -n ${WANT_AUTOMAKE} ]]; then
45 flameeyes 1.49 case ${WANT_AUTOMAKE} in
46 vapier 1.67 none) _automake_atom="" ;; # some packages don't require automake at all
47 vapier 1.99 # if you change the "latest" version here, change also autotools_run_tool
48 robbat2 1.95 # this MUST reflect the latest stable major version for each arch!
49 vapier 1.99 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;;
50 vapier 1.67 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
51 flameeyes 1.49 esac
52 vapier 1.64 export WANT_AUTOMAKE
53 flameeyes 1.48 fi
54    
55 vapier 1.45 if [[ -n ${WANT_AUTOCONF} ]] ; then
56 flameeyes 1.41 case ${WANT_AUTOCONF} in
57 vapier 1.67 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
58     2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
59 flameeyes 1.86 # if you change the “latest” version here, change also autotools_run_tool
60 vapier 1.67 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
61 vapier 1.106 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
62 flameeyes 1.41 esac
63 vapier 1.64 export WANT_AUTOCONF
64 flameeyes 1.41 fi
65 vapier 1.93
66 vapier 1.105 _libtool_atom="sys-devel/libtool"
67     if [[ -n ${WANT_LIBTOOL} ]] ; then
68     case ${WANT_LIBTOOL} in
69     none) _libtool_atom="" ;;
70     latest) ;;
71 vapier 1.106 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
72 vapier 1.105 esac
73     export WANT_LIBTOOL
74     fi
75    
76     AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
77 flameeyes 1.46 RDEPEND=""
78 vapier 1.93
79     # @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
80     # @DESCRIPTION:
81     # Set to 'no' to disable automatically adding to DEPEND. This lets
82     # ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
83     # their own DEPEND string.
84 vapier 1.94 : ${AUTOTOOLS_AUTO_DEPEND:=yes}
85 vapier 1.93 if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
86     DEPEND=${AUTOTOOLS_DEPEND}
87     fi
88    
89 vapier 1.40 unset _automake_atom _autoconf_atom
90 azarah 1.11
91 vapier 1.76 # @ECLASS-VARIABLE: AM_OPTS
92 vapier 1.100 # @DEFAULT_UNSET
93 vapier 1.76 # @DESCRIPTION:
94     # Additional options to pass to automake during
95     # eautoreconf call.
96    
97     # @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
98 vapier 1.100 # @DEFAULT_UNSET
99 vapier 1.76 # @DESCRIPTION:
100     # Don't run elibtoolize command if set to 'yes',
101     # useful when elibtoolize needs to be ran with
102     # particular options
103 azarah 1.16
104 cardoe 1.66 # XXX: M4DIR should be deprecated
105 vapier 1.76 # @ECLASS-VARIABLE: AT_M4DIR
106     # @DESCRIPTION:
107     # Additional director(y|ies) aclocal should search
108 vapier 1.94 : ${AT_M4DIR:=${M4DIR}}
109 azarah 1.11
110 vapier 1.76 # @FUNCTION: eautoreconf
111     # @DESCRIPTION:
112 azarah 1.17 # This function mimes the behavior of autoreconf, but uses the different
113     # eauto* functions to run the tools. It doesn't accept parameters, but
114     # the directory with include files can be specified with AT_M4DIR variable.
115 jmbsvicetto 1.81 #
116 vapier 1.76 # Should do a full autoreconf - normally what most people will be interested in.
117     # Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
118 azarah 1.17 eautoreconf() {
119 vapier 1.91 local x auxdir g
120 jmbsvicetto 1.81
121 flameeyes 1.39 if [[ -z ${AT_NO_RECURSIVE} ]]; then
122     # Take care of subdirs
123     for x in $(autotools_get_subdirs); do
124     if [[ -d ${x} ]] ; then
125 vapier 1.91 pushd "${x}" >/dev/null
126 flameeyes 1.39 AT_NOELIBTOOLIZE="yes" eautoreconf
127 vapier 1.91 popd >/dev/null
128 flameeyes 1.39 fi
129     done
130     fi
131 azarah 1.11
132 flameeyes 1.38 auxdir=$(autotools_get_auxdir)
133    
134 vapier 1.91 einfo "Running eautoreconf in '${PWD}' ..."
135 flameeyes 1.38 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
136 azarah 1.17 eaclocal
137 grobian 1.83 [[ ${CHOST} == *-darwin* ]] && g=g
138     if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
139 vapier 1.72 _elibtoolize --copy --force --install
140     else
141     _elibtoolize --copy --force
142     fi
143 azarah 1.17 eautoconf
144     eautoheader
145 flameeyes 1.35 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
146 azarah 1.1
147 flameeyes 1.32 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
148    
149 flameeyes 1.30 # Call it here to prevent failures due to elibtoolize called _before_
150 vapier 1.84 # eautoreconf. We set $S because elibtoolize runs on that #265319
151 vapier 1.91 S=${PWD} elibtoolize
152 flameeyes 1.30
153 flameeyes 1.21 return 0
154 azarah 1.12 }
155    
156 vapier 1.107 # @FUNCTION: eaclocal_amflags
157 vapier 1.76 # @DESCRIPTION:
158 vapier 1.107 # Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
159     # (most) of the crazy crap that people throw at us.
160     eaclocal_amflags() {
161     local aclocal_opts amflags_file
162 azarah 1.12
163 vapier 1.74 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
164     [[ -e ${amflags_file} ]] || continue
165 vapier 1.103 # setup the env in case the pkg does something crazy
166     # in their ACLOCAL_AMFLAGS. like run a shell script
167 vapier 1.107 # which turns around and runs autotools. #365401
168     # or split across multiple lines. #383525
169 vapier 1.103 autotools_env_setup
170 vapier 1.107 aclocal_opts=$(sed -n \
171     "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
172     # match the first line
173     s:[^=]*=::p; \
174     # then gobble up all escaped lines
175     : nextline /\\\\$/{ n; p; b nextline; } \
176     }" ${amflags_file})
177     eval aclocal_opts=\""${aclocal_opts}"\"
178 vapier 1.74 break
179     done
180    
181 vapier 1.107 echo ${aclocal_opts}
182     }
183    
184     # @FUNCTION: eaclocal
185     # @DESCRIPTION:
186     # These functions runs the autotools using autotools_run_tool with the
187     # specified parametes. The name of the tool run is the same of the function
188     # without e prefix.
189     # They also force installing the support files for safety.
190     # Respects AT_M4DIR for additional directories to search for macro's.
191     eaclocal() {
192 flameeyes 1.22 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
193 vapier 1.107 autotools_run_tool aclocal $(autotools_m4dir_include) "$@" $(eaclocal_amflags)
194 azarah 1.12 }
195    
196 vapier 1.76 # @FUNCTION: _elibtoolize
197     # @DESCRIPTION:
198     # Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
199     # libtool.eclass.
200 azarah 1.12 _elibtoolize() {
201 grobian 1.83 local opts g=
202 swegener 1.20
203 flameeyes 1.34 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
204     # check for both it and the current AC_PROG_LIBTOOL)
205 vapier 1.77 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
206 azarah 1.19
207 flameeyes 1.70 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
208 swegener 1.20
209 grobian 1.83 [[ ${CHOST} == *-darwin* ]] && g=g
210     autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
211 flameeyes 1.15
212 azarah 1.12 # Need to rerun aclocal
213     eaclocal
214 azarah 1.11 }
215 azarah 1.1
216 vapier 1.76 # @FUNCTION: eautoheader
217     # @DESCRIPTION:
218     # Runs autoheader.
219 azarah 1.11 eautoheader() {
220 azarah 1.12 # Check if we should run autoheader
221     [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
222 flameeyes 1.102 NO_FAIL=1 autotools_run_tool autoheader $(autotools_m4dir_include) "$@"
223 azarah 1.11 }
224 azarah 1.1
225 vapier 1.76 # @FUNCTION: eautoconf
226     # @DESCRIPTION:
227     # Runs autoconf.
228 azarah 1.11 eautoconf() {
229 azarah 1.12 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
230     echo
231 vapier 1.91 eerror "No configure.{ac,in} present in '${PWD}'!"
232 azarah 1.12 echo
233     die "No configure.{ac,in} present!"
234     fi
235    
236 flameeyes 1.102 autotools_run_tool autoconf $(autotools_m4dir_include) "$@"
237 azarah 1.11 }
238 azarah 1.1
239 vapier 1.76 # @FUNCTION: eautomake
240     # @DESCRIPTION:
241     # Runs automake.
242 azarah 1.11 eautomake() {
243 flameeyes 1.24 local extra_opts
244 flameeyes 1.70 local makefile_name
245 flameeyes 1.24
246 vapier 1.98 # Run automake if:
247     # - a Makefile.am type file exists
248     # - a Makefile.in type file exists and the configure
249     # script is using the AM_INIT_AUTOMAKE directive
250     for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do
251     [[ -f ${makefile_name} ]] && break
252     done
253     [[ -z ${makefile_name} ]] && return 0
254    
255     if [[ ${makefile_name} == *.in ]] ; then
256     if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
257     return 0
258     fi
259 flameeyes 1.24
260 vapier 1.98 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
261 flameeyes 1.35 local used_automake
262     local installed_automake
263    
264 vapier 1.87 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
265 flameeyes 1.35 sed -e 's:.*(GNU automake) ::')
266 vapier 1.98 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
267 flameeyes 1.35 sed -e 's:.*by automake \(.*\) from .*:\1:')
268    
269     if [[ ${installed_automake} != ${used_automake} ]]; then
270     einfo "Automake used for the package (${used_automake}) differs from"
271     einfo "the installed version (${installed_automake})."
272     eautoreconf
273 flameeyes 1.36 return 0
274 flameeyes 1.35 fi
275     fi
276    
277 flameeyes 1.33 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \
278 flameeyes 1.24 || extra_opts="${extra_opts} --foreign"
279    
280 flameeyes 1.14 # --force-missing seems not to be recognized by some flavours of automake
281 flameeyes 1.24 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
282 azarah 1.1 }
283    
284 vapier 1.90 # @FUNCTION: eautopoint
285     # @DESCRIPTION:
286     # Runs autopoint (from the gettext package).
287     eautopoint() {
288     autotools_run_tool autopoint "$@"
289     }
290    
291 azarah 1.17 # Internal function to run an autotools' tool
292 vapier 1.103 autotools_env_setup() {
293 flameeyes 1.86 # We do the “latest” → version switch here because it solves
294     # possible order problems, see bug #270010 as an example.
295 flameeyes 1.96 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
296 vapier 1.99 local pv
297 flameeyes 1.96 for pv in ${_LATEST_AUTOMAKE} ; do
298 robbat2 1.97 # has_version respects ROOT, but in this case, we don't want it to,
299     # thus "ROOT=/" prefix:
300     ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
301 flameeyes 1.96 done
302     [[ ${WANT_AUTOMAKE} == "latest" ]] && \
303     die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
304     fi
305 flameeyes 1.86 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
306 vapier 1.103 }
307     autotools_run_tool() {
308     if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
309     ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
310     fi
311    
312     autotools_env_setup
313 flameeyes 1.86
314 vapier 1.85 local STDERR_TARGET="${T}/$1.out"
315     # most of the time, there will only be one run, but if there are
316     # more, make sure we get unique log filenames
317     if [[ -e ${STDERR_TARGET} ]] ; then
318 vapier 1.104 local i=1
319     while :; do
320     STDERR_TARGET="${T}/$1-${i}.out"
321     [[ -e ${STDERR_TARGET} ]] || break
322     : $(( i++ ))
323     done
324 vapier 1.85 fi
325 azarah 1.17
326 vapier 1.85 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
327 azarah 1.17
328 azarah 1.27 ebegin "Running $@"
329 vapier 1.85 "$@" >> "${STDERR_TARGET}" 2>&1
330     eend $?
331 azarah 1.17
332 vapier 1.85 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
333 azarah 1.17 echo
334     eerror "Failed Running $1 !"
335     eerror
336     eerror "Include in your bugreport the contents of:"
337     eerror
338 vapier 1.85 eerror " ${STDERR_TARGET}"
339 azarah 1.17 echo
340     die "Failed Running $1 !"
341     fi
342     }
343    
344     # Internal function to check for support
345     autotools_check_macro() {
346 vapier 1.77 [[ -f configure.ac || -f configure.in ]] || return 0
347     local macro
348     for macro ; do
349 flameeyes 1.102 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
350 vapier 1.77 done
351 azarah 1.17 return 0
352     }
353    
354     # Internal function to get additional subdirs to configure
355     autotools_get_subdirs() {
356     local subdirs_scan_out
357    
358     subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
359     [[ -n ${subdirs_scan_out} ]] || return 0
360    
361     echo "${subdirs_scan_out}" | gawk \
362     '($0 !~ /^[[:space:]]*(#|dnl)/) {
363 azarah 1.25 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
364     print res[1]
365 azarah 1.17 }' | uniq
366 azarah 1.16
367 azarah 1.17 return 0
368 azarah 1.11 }
369 azarah 1.17
370 flameeyes 1.38 autotools_get_auxdir() {
371     local auxdir_scan_out
372    
373     auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
374     [[ -n ${auxdir_scan_out} ]] || return 0
375    
376     echo ${auxdir_scan_out} | gawk \
377     '($0 !~ /^[[:space:]]*(#|dnl)/) {
378     if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
379     print res[1]
380     }' | uniq
381    
382     return 0
383 vapier 1.40 }
384 flameeyes 1.102
385     autotools_m4dir_include() {
386     [[ -n ${AT_M4DIR} ]] || return
387    
388     local include_opts=
389    
390     for x in ${AT_M4DIR} ; do
391     case "${x}" in
392     "-I")
393     # We handle it below
394     ;;
395     *)
396     [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
397     include_opts="${include_opts} -I ${x}"
398     ;;
399     esac
400     done
401    
402     echo $include_opts
403     }

  ViewVC Help
Powered by ViewVC 1.1.20